'use strict';var juju={components:{}};describe('UserProfileModelList',function(){var models=void 0,user=void 0;beforeAll(function(done){YUI().use('user-profile-model-list',function(){done();});});beforeEach(function(){models=[{uuid:'model1',name:'spinach/sandbox',lastConnection:'2016-09-12T15:42:09Z',ownerTag:'user-who',owner:'who',isAlive:true}];user={user:'user-who',usernameDisplay:'test owner'};});it('renders the empty state',function(){var acl={canAddModels:function canAddModels(){return true;}};var component=jsTestUtils.shallowRender(React.createElement(juju.components.UserProfileModelList,{acl:acl,addNotification:sinon.stub(),currentModel:'model1',listModelsWithInfo:sinon.stub().callsArgWith(0,null,[]),switchModel:sinon.stub(),user:user}),true);var instance=component.getMountedInstance();var output=component.getRenderOutput();var expected=React.createElement('div',{className:'user-profile__model-list'},React.createElement('div',{className:'user-profile__header twelve-col no-margin-bottom'},'Models',React.createElement('span',{className:'user-profile__size'},'(',0,')'),React.createElement(juju.components.CreateModelButton,{switchModel:instance.switchModel})),undefined,undefined);assert.deepEqual(output,expected);});it('displays loading spinner when loading',function(){var component=jsTestUtils.shallowRender(React.createElement(juju.components.UserProfileModelList,{addNotification:sinon.stub(),currentModel:'model1',listModelsWithInfo:sinon.stub(),switchModel:sinon.stub(),user:user}),true);var output=component.getRenderOutput();assert.deepEqual(output,React.createElement('div',{className:'user-profile__model-list twelve-col'},React.createElement(juju.components.Spinner,null)));});it('renders a list of models',function(){var listModelsWithInfo=sinon.stub().callsArgWith(0,null,models);var acl={canAddModels:function canAddModels(){return true;}};var component=jsTestUtils.shallowRender(React.createElement(juju.components.UserProfileModelList,{acl:acl,addNotification:sinon.stub(),currentModel:'model1',destroyModels:sinon.stub(),listModelsWithInfo:listModelsWithInfo,switchModel:sinon.stub(),user:user}),true);var instance=component.getMountedInstance();var output=component.getRenderOutput();var content=output.props.children[1].props.children;var expected=React.createElement('div',{className:'user-profile__model-list'},React.createElement('div',{className:'user-profile__header twelve-col no-margin-bottom'},'Models',React.createElement('span',{className:'user-profile__size'},'(',1,')'),React.createElement(juju.components.CreateModelButton,{switchModel:instance.switchModel})),React.createElement('ul',{className:'user-profile__list twelve-col'},React.createElement('li',{className:'user-profile__list-header twelve-col'},React.createElement('span',{className:'user-profile__list-col three-col'},'Name'),React.createElement('span',{className:'user-profile__list-col four-col'},'Credential'),React.createElement('span',{className:'user-profile__list-col two-col'},'Last accessed'),React.createElement('span',{className:'user-profile__list-col one-col'},'Units'),React.createElement('span',{className:'user-profile__list-col two-col last-col'},'Owner')),[React.createElement(juju.components.UserProfileEntity,{displayConfirmation:content[1][0].props.displayConfirmation,entity:models[0],expanded:true,key:'model1',switchModel:instance.switchModel,type:'model'},React.createElement('span',{className:'user-profile__list-col three-col'},'spinach/sandbox'),React.createElement('span',{className:'user-profile__list-col four-col'},'--'),React.createElement('span',{className:'user-profile__list-col two-col'},React.createElement(juju.components.DateDisplay,{date:'2016-09-12T15:42:09Z',relative:true})),React.createElement('span',{className:'user-profile__list-col one-col'},'--'),React.createElement('span',{className:'user-profile__list-col two-col last-col'},'who'))]),undefined);assert.deepEqual(output,expected);});it('can render models that are being destroyed',function(){models[0].isAlive=false;var listModelsWithInfo=sinon.stub().callsArgWith(0,null,models);var component=jsTestUtils.shallowRender(React.createElement(juju.components.UserProfileModelList,{addNotification:sinon.stub(),currentModel:'model1',listModelsWithInfo:listModelsWithInfo,switchModel:sinon.stub(),user:user}),true);var output=component.getRenderOutput();var content=output.props.children[1].props.children[1][0];var classes='expanding-row twelve-col user-profile__entity'+' user-profile__list-row';var expected=React.createElement('li',{className:classes,key:'model1'},'spinach/sandbox',' is being destroyed.');assert.deepEqual(content,expected);});it('switches models when calling switchModel method passed to list',function(){var switchModel=sinon.stub();var listModelsWithInfo=sinon.stub().callsArgWith(0,null,models);var component=jsTestUtils.shallowRender(React.createElement(juju.components.UserProfileModelList,{addNotification:sinon.stub(),currentModel:'model1',listModelsWithInfo:listModelsWithInfo,switchModel:switchModel,user:user}),true);var instance=component.getMountedInstance();instance.switchModel('abc123','modelname');assert.equal(switchModel.callCount,1,'switchModel not called');assert.deepEqual(switchModel.args[0],['abc123',[{uuid:'model1',name:'spinach/sandbox',lastConnection:'2016-09-12T15:42:09Z',ownerTag:'user-who',owner:'who',isAlive:true}],'modelname',undefined]);});it('can reset the model connection',function(){var utilsSwitchModel=sinon.stub();var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.UserProfileModelList,{addNotification:sinon.stub(),listModelsWithInfo:sinon.stub(),switchModel:utilsSwitchModel,user:user}),true);var instance=renderer.getMountedInstance();instance.switchModel();assert.equal(utilsSwitchModel.callCount,1,'Model disconnect not called');var switchArgs=utilsSwitchModel.args[0];assert.equal(switchArgs[0],undefined,'UUID should not be defined');});it('can display a confirmation when models are to be destroyed',function(){var listModelsWithInfo=sinon.stub().callsArgWith(0,null,models);var component=jsTestUtils.shallowRender(React.createElement(juju.components.UserProfileModelList,{addNotification:sinon.stub(),currentModel:'model1',destroyModels:sinon.stub(),listModelsWithInfo:listModelsWithInfo,switchModel:sinon.stub(),user:user}),true);var output=component.getRenderOutput();output.props.children[1].props.children[1][0].props.displayConfirmation();output=component.getRenderOutput();var expected=React.createElement(juju.components.ConfirmationPopup,{buttons:output.props.children[2].props.buttons,message:'Are you sure you want to destroy spinach/sandbox? All the '+'applications and units included in the model will be destroyed. '+'This action cannot be undone.',title:'Destroy model'});assert.deepEqual(output.props.children[2],expected);});it('can destroy a model',function(){var addNotification=sinon.stub();var uuids={};models.forEach(function(model){uuids[model.uuid]=null;});var destroyModels=sinon.stub().callsArgWith(1,null,uuids);var listModelsWithInfo=sinon.stub().callsArgWith(0,null,models);var component=jsTestUtils.shallowRender(React.createElement(juju.components.UserProfileModelList,{addNotification:addNotification,currentModel:'model1',destroyModels:destroyModels,listModelsWithInfo:listModelsWithInfo,switchModel:sinon.stub(),user:user}),true);var instance=component.getMountedInstance();instance._displayConfirmation({name:'spinach/my-model'});var output=component.getRenderOutput();output.props.children[2].props.buttons[1].action();assert.equal(destroyModels.callCount,1,'destroyModels not called');output=component.getRenderOutput();assert.isUndefined(output.props.children[2],'Confirmation not hidden');assert.equal(addNotification.callCount,1,'addNotification not called');assert.deepEqual(addNotification.args[0][0],{title:'Model destroyed',message:'The model is currently being destroyed.',level:'important'},'Notification message does not match expected.');});it('can cancel destroying a model',function(){var destroyModels=sinon.stub();var listModelsWithInfo=sinon.stub().callsArgWith(0,null,models);var component=jsTestUtils.shallowRender(React.createElement(juju.components.UserProfileModelList,{addNotification:sinon.stub(),currentModel:'model1',destroyModels:destroyModels,listModelsWithInfo:listModelsWithInfo,switchModel:sinon.stub(),user:user}),true);var instance=component.getMountedInstance();instance._displayConfirmation({name:'spinach/my-model'});var output=component.getRenderOutput();output.props.children[2].props.buttons[0].action();assert.equal(destroyModels.callCount,0,'destroyModels was called');output=component.getRenderOutput();assert.isUndefined(output.props.children[2],'Confirmation not hidden');});it('can display a global error when destroying',function(){var addNotification=sinon.stub();var error='An error';var destroyModels=sinon.stub().callsArgWith(1,error,null);var listModelsWithInfo=sinon.stub().callsArgWith(0,null,models);var component=jsTestUtils.shallowRender(React.createElement(juju.components.UserProfileModelList,{addNotification:addNotification,currentModel:'model1',destroyModels:destroyModels,listModelsWithInfo:listModelsWithInfo,switchModel:sinon.stub(),user:user}),true);var instance=component.getMountedInstance();component.getRenderOutput();instance._displayConfirmation({name:'spinach/my-model',uuid:'my-model'});instance._destroyModel();assert.equal(addNotification.callCount,1);assert.deepEqual(addNotification.args[0][0],{title:'Model destruction failed',message:'The model failed to be destroyed: '+error,level:'error'});});it('can display a specific error when destroying',function(){var addNotification=sinon.stub();var statuses={};var model=models[0];var error='An error.';statuses[model.uuid]=error;var destroyModels=sinon.stub().callsArgWith(1,null,statuses);var listModelsWithInfo=sinon.stub().callsArgWith(0,null,models);var component=jsTestUtils.shallowRender(React.createElement(juju.components.UserProfileModelList,{addNotification:addNotification,currentModel:'model1',destroyModels:destroyModels,listModelsWithInfo:listModelsWithInfo,switchModel:sinon.stub(),user:user}),true);var instance=component.getMountedInstance();component.getRenderOutput();instance._displayConfirmation({name:'spinach/my-model',uuid:'my-model'});instance._destroyModel();assert.equal(addNotification.callCount,1);assert.deepEqual(addNotification.args[0][0],{title:'Model destruction failed',message:'The model failed to be destroyed: '+error,level:'error'});});it('can prevent deletion of a controller',function(){var addNotification=sinon.stub();var destroyModels=sinon.stub();var listModelsWithInfo=sinon.stub().callsArgWith(0,null,models);var component=jsTestUtils.shallowRender(React.createElement(juju.components.UserProfileModelList,{addNotification:addNotification,currentModel:'model1',destroyModels:destroyModels,listModelsWithInfo:listModelsWithInfo,switchModel:sinon.stub(),user:user}),true);var instance=component.getMountedInstance();component.getRenderOutput();var model={name:'spinach/my-model',uuid:'my-model',isController:true};instance._displayConfirmation(model);assert.equal(addNotification.callCount,1,'addNotification was not called');assert.deepEqual(addNotification.args[0][0],{title:'Cannot destroy model',message:'The controller model cannot be destroyed.',level:'error'},'The notification does not match expected.');});it('will abort the requests when unmounting',function(){var listModelsWithInfoAbort=sinon.stub();var listModelsWithInfo=sinon.stub().returns({abort:listModelsWithInfoAbort});var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.UserProfileModelList,{addNotification:sinon.stub(),currentModel:'model1',listModelsWithInfo:listModelsWithInfo,switchModel:sinon.stub(),user:user}),true);renderer.unmount();assert.equal(listModelsWithInfoAbort.callCount,1);});it('broadcasts starting status',function(){var broadcastStatus=sinon.stub();jsTestUtils.shallowRender(React.createElement(juju.components.UserProfileModelList,{addNotification:sinon.stub(),broadcastStatus:broadcastStatus,currentModel:'model1',listModelsWithInfo:sinon.stub(),switchModel:sinon.stub(),user:user}),true);assert.equal(broadcastStatus.args[0][0],'starting');});it('broadcasts ok status',function(){var broadcastStatus=sinon.stub();jsTestUtils.shallowRender(React.createElement(juju.components.UserProfileModelList,{addNotification:sinon.stub(),broadcastStatus:broadcastStatus,currentModel:'model1',listModelsWithInfo:sinon.stub().callsArgWith(0,null,models),switchModel:sinon.stub(),user:user}),true);assert.equal(broadcastStatus.args[1][0],'ok');});it('broadcasts empty status',function(){var broadcastStatus=sinon.stub();jsTestUtils.shallowRender(React.createElement(juju.components.UserProfileModelList,{addNotification:sinon.stub(),broadcastStatus:broadcastStatus,currentModel:'model1',listModelsWithInfo:sinon.stub().callsArgWith(0,null,[]),switchModel:sinon.stub(),user:user}),true);assert.equal(broadcastStatus.args[1][0],'empty');});it('broadcasts error status',function(){var broadcastStatus=sinon.stub();jsTestUtils.shallowRender(React.createElement(juju.components.UserProfileModelList,{addNotification:sinon.stub(),broadcastStatus:broadcastStatus,currentModel:'model1',listModelsWithInfo:sinon.stub().callsArgWith(0,'bad wolf',[]),switchModel:sinon.stub(),user:user}),true);assert.equal(broadcastStatus.args[1][0],'error');});});