'use strict';YUI.add('juju-env-base',function(Y){var module=Y.namespace('juju.environments');var _sessionStorageData={};module.tags={build:function build(type,name){return type+'-'+name;},parse:function parse(type,tag){var prefix=type+'-';if(tag.substr(0,prefix.length)===prefix){return tag.slice(prefix.length);}throw new Error('invalid tag of type '+type+': '+tag);},APPLICATION:'application',CLOUD:'cloud',CONTROLLER:'controller',CREDENTIAL:'cloudcred',MACHINE:'machine',MODEL:'model',UNIT:'unit',USER:'user'};module.PING_INTERVAL=10;module.ADMIN_FACADE_VERSION=3;var attrResetter=function attrResetter(obj){var initial={};return{set:function set(name,value){if(initial[name]===undefined){var val=obj.get(name);if(val===undefined){val=null;}initial[name]=val;}obj.set(name,value);},reset:function reset(){Object.keys(initial).forEach(function(name){var value=initial[name];obj.set(name,value);});}};};module.stubSessionStorage={getItem:function getItem(key){return _sessionStorageData[key]||null;},setItem:function setItem(key,value){_sessionStorageData[key]=value;}};module.verifySessionStorage=function(){try{if(!module.sessionStorage){module.sessionStorage=window.sessionStorage;}module.sessionStorage.getItem('credentials');}catch(e){module.sessionStorage=module.stubSessionStorage;}};module.verifySessionStorage();function BaseEnvironment(config){BaseEnvironment.superclass.constructor.apply(this,arguments);}BaseEnvironment.NAME='base-env';BaseEnvironment.ATTRS={'jujuCoreVersion':{value:''},'socket_url':{},'conn':{},'ecs':{},'user':{},'password':{},'connected':{value:false},'debug':{value:false},'controllerAccess':{value:''},'modelAccess':{value:''},'defaultSeries':{},'providerType':{},'environmentName':{},'modelUUID':{},'webHandler':{},'_silentFailureOps':{value:['update_annotations']},'bundleService':{}};Y.extend(BaseEnvironment,Y.Base,{initializer:function initializer(){this.publish('msg',{emitFacade:true,defaultFn:this.dispatch_result});var resetter=attrResetter(this);this.setConnectedAttr=resetter.set.bind(resetter);this.resetConnectedAttrs=resetter.reset.bind(resetter);this._counter=0;this._txn_callbacks={};this.userIsAuthenticated=false;this.failedAuthentication=false;var credentials=this.getCredentials();if(!credentials.areAvailable){credentials.user=this.get('user')||'';credentials.password=this.get('password')||'';this.setCredentials(credentials);}},destructor:function destructor(){if(this.ws){this.ws.close();}this._txn_callbacks={};},connect:function connect(){var conn=this.get('conn');if(conn){this.ws=conn;}else{var url=this.get('socket_url');console.log('connecting to '+url);this.ws=new jujulib.ReconnectingWebSocket(url);this._txn_callbacks={};}this.ws.debug=this.get('debug');this.ws.onmessage=this.on_message.bind(this);this.ws.onopen=this.on_open.bind(this);this.ws.onclose=this.on_close.bind(this);if(this.ws.open){this.ws.open();}return this;},on_open:function on_open(data){this.set('connected',true);},on_close:function on_close(data){this.set('connected',false);},close:function close(callback){var _this=this;console.log('closing the '+this.name+' API connection');if(!callback){callback=function callback(){};}if(!this.ws){callback();return;}this.cleanup(function(){_this.userIsAuthenticated=false;_this.setCredentials(null);_this.ws.close();callback();});},cleanup:function cleanup(done){done();},on_message:function on_message(evt){this.fire('msg',Y.JSON.parse(evt.data));},dispatch_result:function dispatch_result(data){this._dispatch_rpc_result(data);this._dispatch_event(data);},_firePermissionDenied:function _firePermissionDenied(op){var title='Permission denied';var message='GUI is in read-only mode and this operation '+'requires a model modification';var silent=this.get('_silentFailureOps').some(function(v){return v===op.op;});console.warn(title+': '+message+'. Attempted operation: ',op);if(!silent){this.fire('permissionDenied',{title:title,message:message,op:op});}},setCredentials:function setCredentials(credentials){module.sessionStorage.setItem('credentials',Y.JSON.stringify(credentials));},getCredentials:function getCredentials(){var credentials=JSON.parse(module.sessionStorage.getItem('credentials'));if(!credentials){credentials={};}if(credentials.user){if(credentials.user.indexOf('@')===-1){credentials.user+='@local';}}else{credentials.user='';}if(!credentials.password){credentials.password='';}if(!credentials.macaroons){credentials.macaroons=null;}Object.defineProperties(credentials,{areAvailable:{get:function get(){var creds=!!(this.user&&this.password||this.macaroons);return creds||this.areExternal;}},areExternal:{get:function get(){return!!this.external;}}});return credentials;}});module.BaseEnvironment=BaseEnvironment;},'0.1.0',{requires:['base','json-parse','json-stringify']});